#ifndef SFACE_H
#define SFACE_H

template<class I>class SFace
{
public:
    ~SFace ()
    {
        if (_i)
            _i->Release ();
    }
    I * operator-> () { return _i; }
protected:
    SFace () : _i (0) {}
    SFace (void * i)
    {
        _i = static_cast<I*> (i);
    }
protected:
    I * _i;
};

template<class I, IID const * iid>class SObjFace: public SFace<I>
{
public:
    SObjFace (CoObject & obj)
        : SFace<I> (obj.AcquireInterface (*iid))
    {}
};

#endif
